{$APPTYPE CONSOLE}

uses 
  Windows, Graphics, Types;

var
  SB, TB: TBitmap;
  SL, TL, Land, Obj: TBitmap;
  I, J: Integer;

procedure SDraw(D: TBitmap; X, Y: Integer);
var
  I, J: Integer;
begin
  for I:=0 to D.Width-1 do
   if (X+I>=0)and(X+I<SB.Width) then
    for J:=0 to D.Height-1 do
     if (Y+J>=0)and(Y+J<SB.Height) then
      if D.Canvas.Pixels[I,J]<>0 then
        SB.Canvas.Pixels[X+I,Y+J]:=D.Canvas.Pixels[I,J];
end;

procedure TDraw(D: TBitmap; X, Y: Integer);
var
  I, J: Integer;
begin
  for I:=0 to D.Width-1 do
   if (X+I>=0)and(X+I<TB.Width) then
    for J:=0 to D.Height-1 do
     if (Y+J>=0)and(Y+J<TB.Height) then
      if D.Canvas.Pixels[I,J]<>0 then
        TB.Canvas.Pixels[X+I,Y+J]:=D.Canvas.Pixels[I,J];
end;

procedure Draw(D: TBitmap; X, Y: Integer);
begin
  SDraw(D, X, Y);
  TDraw(D, X, Y);
end;

var
  Colors: array[0..$FFFFFF] of Byte;
  ColorNr: Integer;
  Palette: array[Byte]of TColor;

function Swap(C: TColor): TColor;
begin
  Result:=RGB(GetBValue(C),GetGValue(C),GetRValue(C));
end;

procedure SaveBitmap(B: TBitmap; FileName: string);
var
  I, J: Integer;
  BFH: TBitmapFileHeader;
  BIH: TBitmapInfoHeader;
  F: File;
  C: TColor; V: Byte;
begin
  FillChar(BFH, SizeOf(BFH), 0);
  BFH.bfType:=Ord('B')+Ord('M')*256;
  BFH.bfSize:=SizeOf(BFH)+SizeOf(BIH)+SizeOf(Palette)+B.Width*B.Height;
  BFH.bfOffBits:=SizeOf(BFH)+SizeOf(BIH)+SizeOf(Palette);
  FillChar(BIH, SizeOf(BIH), 0);
  BIH.biSize:=SizeOf(BIH);
  BIH.biWidth:=B.Width;
  BIH.biHeight:=B.Height;
  BIH.biPlanes:=1;
  BIH.biBitCount:=8;
  BIH.biCompression:=BI_RGB;
  BIH.biSizeImage:=0;

  for I:=0 to B.Width-1 do
    for J:=0 to B.Height-1 do
      begin
      C:=Swap(B.Canvas.Pixels[I,J]);
      if C<>0 then
        if Colors[C]=0 then
          begin
          Inc(ColorNr);
          Colors[C]:=ColorNr;
          Palette[ColorNr]:=C;
          end;
      end;

  Assign(F, FileName);
  ReWrite(F, 1);
  BlockWrite(F, BFH, SizeOf(BFH));
  BlockWrite(F, BIH, SizeOf(BIH));
  BlockWrite(F, Palette, SizeOf(Palette));

  for J:=B.Height-1 downto 0 do
    for I:=0 to B.Width-1 do
      begin
      C:=Swap(B.Canvas.Pixels[I,J]);
      if C=0 then
        V:=0
      else
        V:=Colors[C];
      BlockWrite(F, V, 1);
      end;
  Close(F);
end;

begin
  SB:=TBitmap.Create; SB.Canvas.Brush.Color:=clBlack; SB.Width:=256; SB.Height:=224;
  TB:=TBitmap.Create; TB.Canvas.Brush.Color:=clBlack; TB.Width:=256; TB.Height:=224;
  SL:=TBitmap.Create; SL.LoadFromFile('s.layer.spr.bmp');
  TL:=TBitmap.Create; TL.LoadFromFile('t.layer.spr.bmp');
  Land:=TBitmap.Create; Land.LoadFromFile('land.bmp');
  Obj:=TBitmap.Create; Obj.LoadFromFile('objects.bmp');

  SB.Canvas.Brush.Color:=SL.Canvas.Pixels[0, SL.Height-1]; SB.Canvas.FillRect(Rect(0, 25, 256, 224));
  TB.Canvas.Brush.Color:=TL.Canvas.Pixels[0, TL.Height-1]; TB.Canvas.FillRect(Rect(0, 25, 256, 224));

  for I:=0 to 4 do
    begin
    J:=Random(128);
    SDraw(SL, J-256, 20*I); SDraw(SL, J, 20*I); 
    TDraw(TL, J-256, 20*I); TDraw(TL, J, 20*I);
    if I=1 then
      Draw(Land, 128, 20*(I+1) + 25 - Land.Height);
    end;
  Draw(Obj, 0, 224-Obj.Height);

  //SB.SaveToFile('sb.bmp');
  //TB.SaveToFile('tb.bmp');
  SaveBitmap(SB, 'sb.bmp');
  SaveBitmap(TB, 'tb.bmp');
end.
